/*
 * Code for class I18N_UNIX_C_FUNCTIONS
 */

#include "eif_eiffel.h"
#include "../E1/estructure.h"
#include "../E1/eoffsets.h"

#include "i1190.h"
#include <string.h>
#include <locale.h>
#include <eif_langinfo.h>
#include <iconv.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INLINE_F226_3710
static EIF_INTEGER_32 inline_F226_3710 (void)
{
	return LC_ALL;
	;
}
#define INLINE_F226_3710
#endif
#ifndef INLINE_F226_3709
static EIF_POINTER inline_F226_3709 (EIF_INTEGER_32 arg1, EIF_POINTER arg2)
{
	return setlocale((int) arg1, (const char *) arg2);
	;
}
#define INLINE_F226_3709
#endif
#ifndef INLINE_F226_3704
static EIF_POINTER inline_F226_3704 (EIF_INTEGER_32 arg1)
{
	char *dname;
				wchar_t *out = NULL;
				size_t insize, outsize = 0;

				dname = nl_langinfo(arg1);
				insize = strlen(dname) + 1;
				
				{
					iconv_t cd;
					size_t nconv, avail, alloc;
					char *res, *tres, *wrptr, *inptr;
					char **l_inptr = &inptr;

					alloc = avail = insize + insize/4;
					if (!(res = malloc(alloc))) {
					  perror("malloc");
					  return NULL;
					}

					wrptr = res;   /* duplicate pointers because they */
					inptr = dname; /* get modified by iconv */
					
					/*get charset used by current locale */
					#if EIF_OS == EIF_OS_OPENBSD
						char *charset = locale_charset ();
					#else
						char *charset = nl_langinfo (CODESET);
					#endif
					
					cd = iconv_open ("UTF-8", charset);
					if (cd == (iconv_t)(-1)) {
							perror("iconv_open");
							free(res);
							return NULL;
					}

					do {
							nconv = iconv (cd, l_inptr, &insize, &wrptr, &avail); /*convertions */
							if (nconv == (size_t)(-1)) {
									if (errno == E2BIG) { /* need more room for result */
											tres = realloc(res, alloc += 20);
											avail += 20;
											if (!tres) {
													perror("realloc");
													break;
											}
											wrptr = tres + (wrptr - res);
											res = tres;
									}
									else /* something wrong with input */
											break;
							}
					} while (insize);

					if (iconv_close(cd))
							perror("iconv_close");
				   
					out = (wchar_t*) res;
					outsize = wrptr - res; /* should be == to (alloc - avail + 1) */
					/* TODO: should possibly null-terminate the result */
				}
				return out;
	;
}
#define INLINE_F226_3704
#endif
#ifndef INLINE_F226_3706
static EIF_POINTER inline_F226_3706 (void)
{
	#if EIF_OS == EIF_OS_OPENBSD
	return locale_charset ();
#else
	return nl_langinfo (CODESET);
#endif
	;
}
#define INLINE_F226_3706
#endif

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
extern "C" {
#endif

/* {I18N_UNIX_C_FUNCTIONS}.unix_set_locale */
void F226_3702 (EIF_REFERENCE Current, EIF_REFERENCE arg1)
{
	GTCX
	EIF_REFERENCE loc1 = (EIF_REFERENCE) 0;
	EIF_POINTER loc2 = (EIF_POINTER) 0;
	EIF_POINTER loc3 = (EIF_POINTER) 0;
	EIF_POINTER tp1;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	EIF_INTEGER_32 ti4_1;
	RTLD;
	
	RTLI(5);
	RTLR(0,loc1);
	RTLR(1,arg1);
	RTLR(2,tr1);
	RTLR(3,Current);
	RTLR(4,tr2);
	RTLIU(5);
	
	RTGC;
	loc1 = RTLNS(eif_new_type(930, 0x00).id, 930, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F931_13187(RTCW(loc1), arg1);
	ti4_1 = inline_F226_3710();
	{
		/* INLINED CODE (C_STRING.item) */
		tp1 = (EIF_POINTER)  0;
		(void) RTCW(loc1);
		tr1 = *(EIF_REFERENCE *)(loc1);
		tp1 = *(EIF_POINTER *)(RTCW(tr1)+ _PTROFF_0_1_0_1_0_0_);
		/* END INLINED CODE */
	}
	tp1 = tp1;
	loc2 = inline_F226_3709(ti4_1, tp1);
	if ((EIF_BOOLEAN)(loc2 != loc3)) {
		loc1 = RTLNS(eif_new_type(930, 0x00).id, 930, _OBJSIZ_1_0_0_1_0_0_0_0_);
		F931_13191(RTCW(loc1), loc2);
		tr1 = RTOSCF(3708,F226_3708, (Current));
		{
			/* INLINED CODE (C_STRING.string) */
			tr2 = (EIF_REFERENCE)  0;
			(void) RTCW(loc1);
			tp1 = F931_13209(loc1);
			ti4_1 = (EIF_INTEGER_32) strlen((char*) tp1);
			tr2 = F931_13199(loc1, ((EIF_INTEGER_32) 1L), ti4_1);
			/* END INLINED CODE */
		}
		tr2 = tr2;
		{
			/* INLINED CODE (CELL.put) */
			(void) RTCW(tr1);
			RTAR(tr1, tr2);
			*(EIF_REFERENCE *)(tr1) = (EIF_REFERENCE) tr2;
			/* END INLINED CODE */
		}
		;
	} else {
		tr1 = RTOSCF(3708,F226_3708, (Current));
		tr2 = RTMS_EX_H("POSIX",5,1331472728);
		{
			/* INLINED CODE (CELL.put) */
			(void) RTCW(tr1);
			RTAR(tr1, tr2);
			*(EIF_REFERENCE *)(tr1) = (EIF_REFERENCE) tr2;
			/* END INLINED CODE */
		}
		;
	}
	RTLE;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_get_locale_info_managed */
EIF_REFERENCE F226_3703 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	EIF_POINTER tp1;
	EIF_REFERENCE Result = ((EIF_REFERENCE) 0);
	
	RTLD;
	
	RTLI(1);
	RTLR(0,Result);
	RTLIU(1);
	
	RTGC;
	Result = RTLNS(eif_new_type(792, 0x00).id, 792, _OBJSIZ_0_1_0_1_0_1_1_0_);
	tp1 = inline_F226_3704(arg1);
	F793_11066(RTCW(Result), tp1, ((EIF_INTEGER_32) 0L));
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_get_locale_info */
EIF_POINTER F226_3704 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F226_3704 ((EIF_INTEGER_32) arg1);
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_is_available */
EIF_BOOLEAN F226_3705 (EIF_REFERENCE Current, EIF_REFERENCE arg1)
{
	GTCX
	EIF_REFERENCE loc1 = (EIF_REFERENCE) 0;
	EIF_POINTER loc2 = (EIF_POINTER) 0;
	EIF_POINTER tp1;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	EIF_INTEGER_32 ti4_1;
	EIF_BOOLEAN Result = ((EIF_BOOLEAN) 0);
	
	RTLD;
	
	RTLI(5);
	RTLR(0,loc1);
	RTLR(1,arg1);
	RTLR(2,tr1);
	RTLR(3,Current);
	RTLR(4,tr2);
	RTLIU(5);
	
	RTGC;
	loc1 = RTLNS(eif_new_type(930, 0x00).id, 930, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F931_13187(RTCW(loc1), arg1);
	ti4_1 = inline_F226_3710();
	{
		/* INLINED CODE (C_STRING.item) */
		tp1 = (EIF_POINTER)  0;
		(void) RTCW(loc1);
		tr1 = *(EIF_REFERENCE *)(loc1);
		tp1 = *(EIF_POINTER *)(RTCW(tr1)+ _PTROFF_0_1_0_1_0_0_);
		/* END INLINED CODE */
	}
	tp1 = tp1;
	tp1 = inline_F226_3709(ti4_1, tp1);
	Result = (EIF_BOOLEAN) (EIF_BOOLEAN)(tp1 != loc2);
	{
		/* INLINED CODE (I18N_UNIX_C_FUNCTIONS.unix_locale_name) */
		tr1 = (EIF_REFERENCE)  0;
		tr1 = *(EIF_REFERENCE *)(RTCV(RTOSCF(3708,F226_3708, (Current))));
		/* END INLINED CODE */
	}
	tr2 = tr1;
	F226_3702(Current, tr2);
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.c_current_codeset */
EIF_POINTER F226_3706 (EIF_REFERENCE Current)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F226_3706 ();
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_locale_name */
EIF_REFERENCE F226_3707 (EIF_REFERENCE Current)
{
	GTCX
	EIF_REFERENCE Result = ((EIF_REFERENCE) 0);
	
	RTLD;
	
	RTLI(2);
	RTLR(0,Current);
	RTLR(1,Result);
	RTLIU(2);
	
	RTGC;
	Result = *(EIF_REFERENCE *)(RTCV(RTOSCF(3708,F226_3708, (Current))));
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_locale_name_cell */
static EIF_REFERENCE F226_3708_body (EIF_REFERENCE Current)
{
	GTCX
	RTEX;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	RTLD;
	

	RTLI(3);
	RTLR(0,Current);
	RTLR(1,tr1);
	RTLR(2,tr2);
	RTLIU(3);
	
	RTEV;
	RTGC;
	RTOSP (3708);
#define Result RTOSR(3708)
	RTOC_NEW(Result);
	{
		static EIF_TYPE_INDEX typarr0[] = {561,2260,0xFFFF};
		EIF_TYPE typres0;
		static EIF_TYPE typcache0 = {INVALID_DTYPE, 0};
		
		typres0 = (typcache0.id != INVALID_DTYPE ? typcache0 : (typcache0 = eif_compound_id(Dftype(Current), typarr0)));
		tr1 = RTLNS(typres0.id, 561, _OBJSIZ_1_0_0_0_0_0_0_0_);
	}
	tr2 = RTMS_EX_H("POSIX",5,1331472728);
	F562_7635(RTCW(tr1), tr2);
	Result = (EIF_REFERENCE) tr1;
	RTOSE (3708);
	RTLE;
	RTEE;
	return Result;
#undef Result
}

EIF_REFERENCE F226_3708 (EIF_REFERENCE Current)
{
	GTCX
	return RTOSCF(3708,F226_3708_body,(Current));
}

/* {I18N_UNIX_C_FUNCTIONS}.c_setlocale */
EIF_POINTER F226_3709 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1, EIF_POINTER arg2)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F226_3709 ((EIF_INTEGER_32) arg1, (EIF_POINTER) arg2);
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.c_lc_all */
EIF_INTEGER_32 F226_3710 (EIF_REFERENCE Current)
{
	GTCX
	EIF_INTEGER_32 Result = ((EIF_INTEGER_32) 0);
	
	
	
	Result = inline_F226_3710 ();
	return Result;
}

void EIF_Minit190 (void)
{
	GTCX
}


#ifdef __cplusplus
}
#endif
